/*
 *     ReadWriteResolver.java  Mar 24, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.j2xml;
import org.jtool.platform.xml.*;
import org.jtool.platform.util.*;
import org.jtool.platform.xml.wrapper.*;
import org.w3c.dom.*;

public class ReadWriteResolver extends SimpleResolver {

    public static Document run(JavaXMLText text) {
        return run(text.getDocument());
    }

    public static Document run(Document doc) {
        Element elem = doc.getDocumentElement();
        setReadWriteExpr(elem.getElementsByTagName(JXConstants.ExpressionElem));

        return doc;
    }

    private static void setReadWriteExpr(NodeList nl) {
        for (int i = 0; i < nl.getLength(); i++) {
            Element elem = (Element)nl.item(i);

            if (elem.getAttribute(JXConstants.SortAttr).equals(JXConstants.VarRef)) {
                setReadWriteExpr(elem);
            }
        }
    }

    private static void setReadWriteExpr(Element elem) {
        Element pelem = (Element)elem.getParentNode();

        if (!pelem.getNodeName().equals(JXConstants.FieldElem) &&
            !pelem.getNodeName().equals(JXConstants.LocalElem)) {
            
            String read = elem.getAttribute(JXConstants.ReadAttr);
            String write = elem.getAttribute(JXConstants.WriteAttr);

            if (read.length() == 0 && write.length() == 0) {
                elem.setAttribute(JXConstants.ReadAttr, JXConstants.YES);
                elem.setAttribute(JXConstants.WriteAttr, JXConstants.YES);
            }
        }
    }
}
