/*
 *     CFGParameterNode.java  Dec 18, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.graph.cfg;
import org.jtool.platform.xml.graph.*;
import org.jtool.platform.xml.wrapper.*;
import org.w3c.dom.Element;

public class CFGParameter extends CFGStatement {
    private int ordinal;

    private CFGParameter() {
    }

    public CFGParameter(int sort, Element elem) {
        super(sort, elem);
    }

    public CFGParameter(int sort, Element elem, int n) {
        super(sort, elem);
        ordinal = n;
    }

    public void setOrdinal(int n) {
        ordinal = n;
    }

    public int getOrdinal() {
        return ordinal;
    }

    public void setDefVariable(JavaParameter jp) {
        defs.add(jp.getJavaVariable());
    }

    public void setUseVariable(JavaParameter jp) {
        uses.add(jp.getJavaVariable());
    }

    public JavaVariable getDefVariable() {
        return defs.get(0);
    }

    public JavaVariable getUseVariable() {
        return uses.get(0);
    }

    public void print(StringBuffer buf) {
        String mesg = "";
        switch (sort) {
            case GraphNodeSort.formalIn: mesg = "formal_in"; break;
            case GraphNodeSort.formalOut: mesg = "formal_out"; break;
            case GraphNodeSort.actualIn: mesg = "actual_in"; break;
            case GraphNodeSort.actualOut: mesg = "actual_out"; break;
        }
        mesg = mesg + " ";
        printDefUse(mesg, buf);
    }
}
